@echo off

rem   This batch file implements automatic error location for djgpp v2.
rem   You should use it instead of running make.exe directly. It calls make,
rem   redirecting stderr into a file. If make fails it then passes this file
rem   to FED with the -e command line option. If you exit from FED with the
rem   'Save and quit' command it will repeat the make, otherwise it will
rem   abort.
rem
rem   To redirect stderr, this file uses the redir utility which is supplied
rem   with djgpp v2. If you don't have this, you will need some other way
rem   of redirecting stderr (eg. 4dos).

:tryagain
redir -e _errors_ make.exe %1 %2 %3 %4 %5 %6 %7 %8 %9
if not errorlevel 1 goto finished

fed -e _errors_
if not errorlevel 1 goto tryagain

:finished
type _errors_
del _errors_ > nul
