/***********************************************************************/
/* QUERY.H -                                                           */
/* This file contains defines   related to QUERY,STATUS and EXTRACT    */
/***********************************************************************/
/*
 * THE - The Hessling Editor. A text editor similar to VM/CMS xedit.
 * Copyright (C) 1991-1996 Mark Hessling
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to:
 *
 *    The Free Software Foundation, Inc.
 *    675 Mass Ave,
 *    Cambridge, MA 02139 USA.
 *
 *
 * If you make modifications to this software that you feel increases
 * it usefulness for the rest of the community, please email the
 * changes, enhancements, bug fixes as well as any and all ideas to me.
 * This software is going to be maintained and enhanced as deemed
 * necessary by the community.
 *
 * Mark Hessling                 Email:             M.Hessling@qut.edu.au
 * PO Box 203                    Phone:                    +617 3849 7731
 * Bellara                       http://www.gu.edu.au/gwis/the/markh.html
 * QLD 4507                      **** Maintainer PDCurses & REXX/SQL ****
 * Australia                     ************* Author of THE ************
 */

/*
$Id: query.h 2.1 1995/06/24 16:30:57 MH Rel MH $
*/


/*---------------------------------------------------------------------*/
/* The order of these items determine the order they appear as a result*/
/* of the STATUS command, so they should be in alphabetical order.     */
/*---------------------------------------------------------------------*/
/* The following are item number defines for EXTRACT/QUERY/STATUS.     */
/*---------------------------------------------------------------------*/
#define ITEM_ALT                              0
#define ITEM_ARBCHAR                          1
#define ITEM_AUTOSAVE                         2
#define ITEM_BACKUP                           3
#define ITEM_BEEP                             4
#define ITEM_BLOCK                            5
#define ITEM_CASE                             6
#define ITEM_CLEARSCREEN                      7
#define ITEM_CLOCK                            8
#define ITEM_CMDARROWS                        9
#define ITEM_CMDLINE                         10
#define ITEM_COLOR                           11
#define ITEM_COLUMN                          12
#define ITEM_COMPAT                          13
#define ITEM_CURLINE                         14
#define ITEM_CURSOR                          15
#define ITEM_CURSORSTAY                      16
#define ITEM_DIRFILEID                       17
#define ITEM_DISPLAY                         18
#define ITEM_EOF                             19
#define ITEM_EOLOUT                          20
#define ITEM_ETMODE                          21
#define ITEM_FNAME                           22
#define ITEM_FPATH                           23
#define ITEM_FTYPE                           24
#define ITEM_GETENV                          25
#define ITEM_HEX                             26
#define ITEM_HEXDISPLAY                      27
#define ITEM_HEXSHOW                         28
#define ITEM_IDLINE                          29
#define ITEM_IMPMACRO                        30
#define ITEM_IMPOS                           31
#define ITEM_INSERTMODE                      32
#define ITEM_LASTMSG                         33
#define ITEM_LASTRC                          34
#define ITEM_LENGTH                          35
#define ITEM_LINE                            36
#define ITEM_LINEND                          37
#define ITEM_LSCREEN                         38
#define ITEM_MACROEXT                        39
#define ITEM_MACROPATH                       40
#define ITEM_MARGINS                         41
#define ITEM_MONITOR                         42
#define ITEM_MSGLINE                         43
#define ITEM_MSGMODE                         44
#define ITEM_NBFILE                          45
#define ITEM_NEWLINES                        46
#define ITEM_NONDISP                         47
#define ITEM_NUMBER                          48
#define ITEM_PENDING                         49
#define ITEM_POINT                           50
#define ITEM_POSITION                        51
#define ITEM_PREFIX                          52
#define ITEM_PRINTER                         53
#define ITEM_READV                           54
#define ITEM_REPROFILE                       55
#define ITEM_RESERVED                        56
#define ITEM_REXXOUTPUT                      57
#define ITEM_RING                            58
#define ITEM_SCALE                           59
#define ITEM_SCOPE                           60
#define ITEM_SCREEN                          61
#define ITEM_SELECT                          62
#define ITEM_SHADOW                          63
#define ITEM_SHOWKEY                         64
#define ITEM_SIZE                            65
#define ITEM_STATUSLINE                      66
#define ITEM_STAY                            67
#define ITEM_TABKEY                          68
#define ITEM_TABLINE                         69
#define ITEM_TABS                            70
#define ITEM_TABSIN                          71
#define ITEM_TABSOUT                         72
#define ITEM_TERMINAL                        73
#define ITEM_TOF                             74
#define ITEM_TYPEAHEAD                       75
#define ITEM_VERIFY                          76
#define ITEM_VERSHIFT                        77
#define ITEM_VERSION                         78
#define ITEM_WIDTH                           79
#define ITEM_WORDWRAP                        80
#define ITEM_XTERMINAL                       81
#define ITEM_ZONE                            82
/*---------------------------------------------------------------------*/
/* The following are item number defines for the boolean functions.    */
/*---------------------------------------------------------------------*/
#define ITEM_AFTER_FUNCTION                 100
#define ITEM_BATCH_FUNCTION                 101
#define ITEM_BEFORE_FUNCTION                102
#define ITEM_BLANK_FUNCTION                 103
#define ITEM_BLOCK_FUNCTION                 104
#define ITEM_BOTTOMEDGE_FUNCTION            105
#define ITEM_COMMAND_FUNCTION               106
#define ITEM_CURRENT_FUNCTION               107
#define ITEM_DIR_FUNCTION                   108
#define ITEM_END_FUNCTION                   109
#define ITEM_EOF_FUNCTION                   110
#define ITEM_FILELINE_FUNCTION              111
#define ITEM_FIRST_FUNCTION                 112
#define ITEM_FOCUSEOF_FUNCTION              113
#define ITEM_FOCUSTOF_FUNCTION              114
#define ITEM_INBLOCK_FUNCTION               115
#define ITEM_INCOMMAND_FUNCTION             116
#define ITEM_INITIAL_FUNCTION               117
#define ITEM_INPREFIX_FUNCTION              118
#define ITEM_LEFTEDGE_FUNCTION              119
#define ITEM_MODIFIABLE_FUNCTION            120
#define ITEM_MULTWINDOW_FUNCTION            121
#define ITEM_RIGHTEDGE_FUNCTION             122
#define ITEM_SPACECHAR_FUNCTION             123
#define ITEM_TOF_FUNCTION                   124
#define ITEM_TOPEDGE_FUNCTION               125
#define ITEM_VERONE_FUNCTION                126
/*---------------------------------------------------------------------*/
/* The following are item number defines for the 'other' functions.    */
/*---------------------------------------------------------------------*/
#define ITEM_VALID_TARGET_FUNCTION          201
#define ITEM_RUN_OS_FUNCTION                202

#define MAX_VARIABLES_RETURNED               20
